/*
 * GPJVector2D.java v1.1
 *
 * Copyright (C) 2010  by Giuseppe Perniola
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class GPJVector2D
{

    public float m_x;
    public float m_y;

    public GPJVector2D()
    {
    }

    public GPJVector2D(float x,
                       float y)
    {
        set(x,
                y);
    }

    public void set(float x,
                    float y)
    {
        m_x = x;
        m_y = y;
    }

    public static void copyVector(GPJVector2D src,
                                  GPJVector2D dst)
    {
        dst.m_x = src.m_x;
        dst.m_y = src.m_y;
    }

    public static void subVectors(GPJVector2D src1,
                                  GPJVector2D src2,
                                  GPJVector2D dst)
    {
        dst.m_x = src1.m_x - src2.m_x;
        dst.m_y = src1.m_y - src2.m_y;
    }
    
    public static void interpolatesVectors(GPJVector2D  src1,
                                           GPJVector2D  src2,
                                           GPJVector2D  dst,
                                           float        rate)
    {
        float x1;
        float y1;
        float x2;
        float y2;
        
        x1 = src1.m_x;
        y1 = src1.m_y;
        x2 = src2.m_x;
        y2 = src2.m_y;
       
        dst.m_x = x1 + (x2 - x1) * rate;
        dst.m_y = y1 + (y2 - y1) * rate;
    }

    public static void exchangeVectors(GPJVector2D vector1,
                                       GPJVector2D vector2)
    {
        float x;
        float y;

        x           = vector1.m_x;
        y           = vector1.m_y;
        vector1.m_x = vector2.m_x;
        vector1.m_y = vector2.m_y;
        vector2.m_x = x;
        vector2.m_y = y;
    }

    @Override
    public String toString()
    {
        return super.toString() + "  x: " + m_x + "  y: " + m_y;
    }

}
